CREATE DATABASE Azienda;

USE Azienda;

CREATE TABLE Dipartimento (
id_dipartimento VARCHAR(3) NOT NULL,
nome_dipartimento VARCHAR(30),
localita VARCHAR(20),
provincia VARCHAR(2),
CONSTRAINT chiave_primaria PRIMARY KEY (id_dipartimento)
);

INSERT INTO Dipartimento (id_dipartimento, nome_dipartimento, localita, provincia) VALUES
('D1', 'ALFA', 'Livorno', 'LI'),
('D2', 'BETA', 'Pisa', 'PI'),
('D3', 'GAMMA', 'Piombino', 'LI'),
('D4', 'DELTA', 'Lucca', 'LU'),
('D5', 'OMEGA', 'Firenze', 'FI');

CREATE TABLE Personale (
matricola VARCHAR(5) NOT NULL,
id_dipartimento VARCHAR(3),
nominativo VARCHAR(50),
data_nascita DATE,
qualifica VARCHAR(2),
stipendio DOUBLE,
CONSTRAINT chiave_primaria PRIMARY KEY (matricola),
CONSTRAINT dipartimenti_personale FOREIGN KEY (id_dipartimento)
REFERENCES Dipartimento(id_dipartimento)
);

INSERT INTO Personale ( matricola, id_dipartimento, nominativo, data_nascita, qualifica, stipendio) VALUES
('00013','D1','ROSSI PIERO','1965-01-15','01',1640.00),
('00034','D2','NERI GIOVANNI','1964-08-05','02',2530.00),
('00075','D4','ARNETTI MARIA','1967-01-15','01',1750.00),
('04346','D3','BELLI DANIELA','1967-02-25','01',1740.00),
('04434','D2','VERDI MARCO','1977-05-09','03',3480.00),
('04450','D3','SANDRI DONATA','1969-05-01','02',2470.00),
('04532','D3','GIANNINI PIETRO','1968-06-04','01',1580.00),
('04541','D3','TESINI MARIO','1968-12-28','02',2740.00),
('04551','D1','BIANCHI MAURO','1968-07-09','02',2580.00),
('04717','D2','PIERINI MARIO','1969-06-20','01',1520.00),
('04794','D2','CARLETTI PAOLO','1971-07-02','01',1670.00),
('05019','D4','SOLDANI GIULIO','1973-03-27','02',2480.00),
('05462','D3','LAPINI PAOLO','1967-01-11','03',3960.00),
('05477','D4','BRESCHI CARLA','1976-05-02','02',2600.00);
