
import java.sql.*;

public class GestioneLibri {
    final String URL = "jdbc:mysql://localhost:3306";
    final String database = "Libri";
    final String user = "root";
    final String password = "";
    private Connection con;

    public GestioneLibri() throws SQLException {
        con = DriverManager.getConnection(URL+"/"+database, user, password);
    }
    
    /* Inserimento nuovo libro nel database */
    public boolean aggiungiLibro(Libro libro) {
        Statement stat;
        ResultSet result;
        String id_autore;
        String id_editore;
        String data_nascita;
        try { // ricerca identificatore autore a partire dal nome
            stat = con.createStatement();
            String query = "SELECT id_autore FROM Autori WHERE nome = '" + libro.getNome_autore() + "' AND cognome = '" + libro.getCognome_autore() + "';";
            result = stat.executeQuery(query);
            result.next();
            id_autore = result.getString(1);
            result.close();
            stat.close();
        }
        catch (SQLException exception) {
            return false;
        }
        try { // ricerca identificatore editore a partire dal nome
            stat = con.createStatement();
            String query = "SELECT id_editore FROM Editori WHERE ragione_sociale = '" + libro.getEditore() + "';";
            result = stat.executeQuery(query);
            result.next();
            id_editore = result.getString(1);
            result.close();
            stat.close();
        }
        catch (SQLException exception) {
            return false;
        }
        try {
            stat = con.createStatement();
            String command = "INSERT INTO Libri(ISBN, titolo, lingua, anno, costo, id_autore, id_editore) VALUES ('" + libro.getISBN() + "', '" + libro.getTitolo() + "', '" + libro.getLingua() + "', " + libro.getAnno() + ", " + libro.getCosto() + ", '" + id_autore + "', '" + id_editore + "');";
            if (stat.executeUpdate(command) == 0) {
                return false;
            }
            stat.close();
        }
        catch (SQLException exception) {
            return false;
        }
        return true;
    }


    /* Ricerca nel database i dati di tutti i libri */
    public Libro[] elencoLibri(int da_anno, int a_anno) {
        Libro elenco_libri[];
        Statement stat;
        ResultSet result;
        int numero_libri;
        int conta_libri;
        String ISBN;
        String titolo;
        String lingua;
        double costo;
        String nome_autore;
        String cognome_autore;
        String editore;
        int anno;
        
        try { // conteggio libri presenti nel database
            stat = con.createStatement();
            String query = "SELECT COUNT(*) AS numero FROM Libri WHERE anno>=" + da_anno + " AND anno<=" + a_anno +";";
            result = stat.executeQuery(query);
            result.next();
            numero_libri = result.getInt(1);
            if (numero_libri > 0) {
                elenco_libri = new Libro[numero_libri];
            }
            else {
                return null;
            }
            result.close();
            stat.close();
        }
        catch (SQLException exception) {
            return null;
        }
        try {
            stat = con.createStatement();
            String query = "SELECT * FROM Libri, Autori, Editori WHERE Libri.id_autore = Autori.id_autore AND Libri.id_editore = Editori.id_editore AND anno>=" + da_anno + " AND anno<=" + a_anno +" ORDER BY anno;";
            result = stat.executeQuery(query);
            conta_libri = 0;
            while (result.next()) {
                ISBN = result.getString("ISBN");
                titolo = result.getString("titolo");
                lingua = result.getString("lingua");
                anno = result.getInt("anno");
                nome_autore = result.getString("nome");
                cognome_autore = result.getString("cognome");
                costo = result.getDouble("costo");
                editore = result.getString("ragione_sociale");
                elenco_libri[conta_libri] = new Libro(ISBN, titolo, lingua, anno, costo, cognome_autore, nome_autore, editore);
                conta_libri++;
            }
            result.close();
            stat.close();
            return elenco_libri;
        }
        catch (SQLException exception) {
            return null;
        }
    }

    /* Eliminazione libro dal database */
    public boolean eliminaLibro(String ISBN) {
        Statement stat;
        ResultSet result;
        
        try {
            stat = con.createStatement();
            String command = " DELETE FROM Libri WHERE ISBN = '" + ISBN + "';";
            if (stat.executeUpdate(command) == 0) {
                return false;
            }
            stat.close();
        }
        catch (SQLException exception) {
            return false;
        }
        return true;
    }

    public static void main(String args[]) {
        Libro libro = new Libro("9788808160287", "Computer LAB", "Italiano", 2014, 21.40, "Di Palma", "Giuseppe", "Zanichelli");
        GestioneLibri gestione_libri;
        Libro elenco_libri[];

        try {
            gestione_libri = new GestioneLibri();
        }
        catch (SQLException exception) {
            System.out.println("Errore connessione server DBMS.");
            return;
        }
        if (gestione_libri.aggiungiLibro(libro)) {
            System.out.println("Libro aggiunto al database.");
        }
        else {
            System.out.println("Errore aggiunta libro al database.");
        }
        elenco_libri = gestione_libri.elencoLibri(2013, 2014);
        if (elenco_libri != null) {
            System.out.println("Elenco libri: ");
            for (int i=0; i<elenco_libri.length; i++) {
                System.out.println(elenco_libri[i]);
            }
        }
        else {
            System.out.println("Errore ricerca libri nel database.");
        }
        if (gestione_libri.eliminaLibro("9788808160287")) {
            System.out.println("Libro eliminato dal database.");
        }
        else {
            System.out.println("Errore eliminazione libro dal database.");
        }
    }
}
