
import java.sql.*;
import javax.sql.*;
import javax.sql.rowset.*;
import com.sun.rowset.*;

public class GestionePersonale {
    final String URL = "jdbc:mysql://localhost:3306";
    final String database = "Azienda";
    final String user = "root";
    final String password = "";
    private Connection con;
    private JdbcRowSet rowset;
    
    public GestionePersonale() throws SQLException {
        con = DriverManager.getConnection(URL+"/"+database, user, password);
        rowset = new JdbcRowSetImpl(con);
        rowset.setCommand("SELECT * FROM Personale;");
        rowset.execute();
    }
    
    /* Inserimento unità di personale nel database */
    public boolean aggiungiPersonale(Personale personale) {
        Statement stat;
        ResultSet result;
        String id_dipartimento;

        try { // ricerca identificatore dipartimento a partire dal nome
            stat = con.createStatement();
            String query = " SELECT id_dipartimento FROM Dipartimento WHERE nome_dipartimento = '" + personale.getDipartimento() + "';";
            result = stat.executeQuery(query);
            result.next();
            id_dipartimento = result.getString(1);
            result.close();
            stat.close();
        }
        catch (SQLException exception) {
            return false;
        }
        try {
            rowset.moveToInsertRow();
            rowset.updateString("matricola", personale.getMatricola());
            rowset.updateString("id_dipartimento", id_dipartimento);
            rowset.updateString("nominativo", personale.getNominativo());
            rowset.updateDate("data_nascita", personale.getDataNascita());
            rowset.updateString("qualifica", personale.getQualifica());
            rowset.updateDouble("stipendio", personale.getStipendio());
            rowset.insertRow();
            return true;
        }
        catch (SQLException exception) {
            return false;
        }
    }
    
    /* Aggiornamento dati unità di personale nel database */
    public boolean aggiornaPersonale(Personale personale) {
        Statement stat;
        ResultSet result;
        String id_dipartimento;
        String data_nascita;
        try { // ricerca identificatore dipartimento a partire dal nome
            stat = con.createStatement();
            String query = " SELECT id_dipartimento FROM Dipartimento WHERE nome_dipartimento = '" + personale.getDipartimento() +"';";
            result = stat.executeQuery(query);
            result.next();
            id_dipartimento = result.getString(1);
            result.close();
            stat.close();
        }
        catch (SQLException exception) {
            return false;
        }
        try {
            rowset.beforeFirst();
            while (rowset.next()) { // ricerca record
                if ( rowset.getString("matricola").equals(personale.getMatricola())) {
                    rowset.updateString("id_dipartimento", id_dipartimento);
                    rowset.updateString("nominativo", personale.getNominativo());
                    rowset.updateDate("data_nascita", personale.getDataNascita());
                    rowset.updateString("qualifica", personale.getQualifica());
                    rowset.updateDouble("stipendio", personale.getStipendio());
                    rowset.updateRow();
                    return true;
                }
            }
            return false;
        }
        catch (SQLException exception) {
            return false;
        }
    }

    /* Ricerca nel database i dati di una unità di personale */
    public Personale datiPersonale(String matricola) {
        Personale personale;
        Statement stat;
        ResultSet result;
        String nominativo;
        Date data_nascita;
        String id_dipartimento;
        String nome_dipartimento;
        String qualifica;
        double stipendio;

        try {
            rowset.beforeFirst();
            while (rowset.next()) { // ricerca record
                if (rowset.getString("matricola").equals(matricola)) {
                    id_dipartimento = rowset.getString("id_dipartimento");
                    nominativo = rowset.getString("nominativo");
                    data_nascita = rowset.getDate("data_nascita");
                    qualifica = rowset.getString("qualifica");
                    stipendio = rowset.getDouble("stipendio"); 
                    stat = con.createStatement();
                    String query = " SELECT nome_dipartimento FROM Dipartimento WHERE id_dipartimento = '" + id_dipartimento +"';";
                    result = stat.executeQuery(query);
                    result.next();
                    nome_dipartimento = result.getString(1);
                    result.close();
                    stat.close();
                    personale = new Personale( matricola, nome_dipartimento, nominativo, qualifica, data_nascita, stipendio);
                    return personale;
                }
            }
            return null;
        }
        catch (SQLException exception) {
            return null;
        }
    }

    /* Ricerca nel database i dati di tutte le unità di personale */
    public Personale[] elencoPersonale() {
        Personale elenco_personale[];
        Statement stat;
        ResultSet result;
        int numero_personale;
        String matricola;
        String nominativo;
        Date data_nascita;
        String id_dipartimento;
        String nome_dipartimento;
        String qualifica;
        double stipendio;

        try { // conteggio record
            rowset.beforeFirst();
            numero_personale = 0;
            while (rowset.next()) {
                numero_personale++;
            }
            if (numero_personale > 0) {
                elenco_personale = new Personale[numero_personale];
            }
            else {
                return null;
            }
        }
        catch (SQLException exception) {
            return null;
        }
        try {
            rowset.beforeFirst();
            numero_personale = 0;
            while (rowset.next()) {
                matricola = rowset.getString("matricola");
                id_dipartimento = rowset.getString("id_dipartimento");
                nominativo = rowset.getString("nominativo");
                data_nascita = rowset.getDate("data_nascita");
                qualifica = rowset.getString("qualifica");
                stipendio = rowset.getDouble("stipendio");
                stat = con.createStatement();
                String query = "SELECT nome_dipartimento FROM Dipartimento WHERE id_dipartimento = '" + id_dipartimento +"';";
                result = stat.executeQuery(query);
                result.next();
                nome_dipartimento = result.getString(1);
                result.close();
                stat.close();
                elenco_personale[numero_personale] = new Personale(matricola, nome_dipartimento, nominativo, qualifica, data_nascita, stipendio);
                numero_personale++;
            }
            return elenco_personale;
        }
        catch (SQLException exception) {
            return null;
        }
    }

    /* Eliminazione unità di personale dal database */
    public boolean eliminaPersonale(String matricola) {
        Statement stat;
        ResultSet result;

        try {
            rowset.beforeFirst();
            while (rowset.next()) { // ricerca record
                if (rowset.getString("matricola").equals(matricola)) {
                    rowset.deleteRow();
                    return true;
                }
            }
            return false;
        }
        catch (SQLException exception) {
            return false;
        }
    }

    public static void main(String args[]) {
        Date data_nascita = new Date(65, 2, 23); // 23-3-1965
        Personale personale = new Personale( "01234","ALFA","MEINI GIORGIO", "09",data_nascita,9999.99);
        GestionePersonale gestione_personale;
        Personale elenco_personale[];

        try {
            gestione_personale = new GestionePersonale();
        }
        catch (SQLException exception) {
            System.out.println("Errore connessione server DBMS.");
            return;
        }
        if (gestione_personale.aggiungiPersonale(personale)) {
            System.out.println("Unità di personale aggiunta al database.");
        }
        else {
            System.out.println("Errore aggiunta unità di personale.");
        }
        elenco_personale = gestione_personale.elencoPersonale();
        if (elenco_personale != null) {
            System.out.println("Elenco personale: ");
            for (int i=0; i<elenco_personale.length; i++) {
                System.out.println(elenco_personale[i]);
            }
        }
        else {
            System.out.println("Errore ricerca unità di personale.");
        }
        personale.setQualifica("00");
        personale.setStipendio(999.99);
        if (gestione_personale.aggiornaPersonale(personale)) {
            System.out.println("Unità di personale del database aggiornata.");
        }
        else {
            System.out.println("Errore aggiornamento unità di personale.");
        }
        personale = gestione_personale.datiPersonale("01234");
        if (personale != null) {
            System.out.println("Unità di personale: " + personale);
        }
        else {
            System.out.println("Errore ricerca unità di personale.");
        }
        if (gestione_personale.eliminaPersonale("01234")) {
            System.out.println("Unità di personale eliminata dal database.");
        }
        else {
            System.out.println("Errore eliminazione unità di personale.");
        }
    }
}
