CREATE DATABASE Libri;

USE Libri;

CREATE TABLE Autori (
id_autore CHAR(5) NOT NULL,
cognome VARCHAR(20) NOT NULL,
nome VARCHAR(20) NOT NULL,
data_nascita DATE,
nazione VARCHAR(15),
sesso CHAR(1),
CONSTRAINT chiave_primaria PRIMARY KEY (id_autore)
);

INSERT INTO Autori (id_autore, cognome, nome, data_nascita, nazione, sesso) VALUES
('00001', 'Formichi', 'Fiorenzo', '1955-10-07', 'Italia', 'M'),
('00002', 'Meini', 'Giorgio', '1965-03-23', 'Italia', 'M'),
('00003', 'Di Palma', 'Giuseppe', '1965-12-04', 'Italia', 'M');

CREATE TABLE Editori (
id_editore CHAR(5) NOT NULL,
ragione_sociale VARCHAR(40) NOT NULL,
indirizzo VARCHAR(50),
citta VARCHAR(20),
CONSTRAINT chiave_primaria PRIMARY KEY (id_editore)
);

INSERT INTO Editori (id_editore, ragione_sociale, indirizzo, citta) VALUES
('00001', 'ZANICHELLI', 'Via Irnerio, 34', 'Bologna');


CREATE TABLE Libri (
ISBN CHAR(13) NOT NULL,
titolo VARCHAR(50) NOT NULL,
lingua VARCHAR(15),
anno INTEGER,
costo REAL,
id_autore CHAR(5),
id_editore CHAR(5),
CONSTRAINT chiave_primaria PRIMARY KEY (ISBN),
CONSTRAINT libri_autori FOREIGN KEY (id_autore) REFERENCES Autori(id_autore),
CONSTRAINT libri_editori FOREIGN KEY (id_editore) REFERENCES Editori(id_editore)
);

INSERT INTO Libri (ISBN, titolo, lingua, anno, costo, id_autore, id_editore) VALUES
('9788808245427', 'Corso di Informatica', 'Italiano', 2013, 29.90, '00001', '00001'),
('9788808735010', 'Tecnologie e progettazione di sistemi informatici', 'Italiano', 2014, 24.80, '00002', '00001');
