
import java.sql.*;


public class Spedizione {
    private int codice_spedizione;
    private Timestamp data_ora_spedizione;
    private Timestamp data_ora_consegna;
    private double peso;
    private double costo;
    private Cliente mittente;
    private Cliente destinatario;
    private Sede sede_partenza;
    private Sede sede_arrivo;

    public Spedizione(int codice_spedizione, Timestamp data_ora_partenza, double peso, double costo, Cliente mittente, Cliente destinatario, Sede sede_partenza, Sede sede_arrivo) {
        this.codice_spedizione = codice_spedizione;
        this.data_ora_spedizione = data_ora_partenza;
        this.data_ora_consegna = new Timestamp(100, 0, 1, 0, 0, 0, 0); // 2000-01-01 00:00:00
        this.peso = peso;
        this.costo = costo;
        this.mittente = mittente;
        this.destinatario = destinatario;
        this.sede_partenza = sede_partenza;
        this.sede_arrivo = sede_arrivo;
    }

    public Spedizione() {
        this.codice_spedizione = 0;
        this.data_ora_spedizione = new Timestamp(100, 0, 1, 0, 0, 0, 0); // 2000-01-01 00:00:00
        this.data_ora_consegna = new Timestamp(100, 0, 1, 0, 0, 0, 0); // 2000-01-01 00:00:00
        this.peso = 0.0;
        this.costo = 0.0;
        this.mittente = null;
        this.destinatario = null;
        this.sede_partenza = null;
        this.sede_arrivo = null;
    }
    
    public int getCodice_spedizione() {
        return codice_spedizione;
    }

    public Timestamp getData_ora_spedizione() {
        return data_ora_spedizione;
    }

    public Timestamp getData_ora_consegna() {
        return data_ora_consegna;
    }

    public double getPeso() {
        return peso;
    }

    public double getCosto() {
        return costo;
    }

    public Cliente getMittente() {
        return mittente;
    }

    public Cliente getDestinatario() {
        return destinatario;
    }

    public Sede getSede_partenza() {
        return sede_partenza;
    }

    public Sede getSede_arrivo() {
        return sede_arrivo;
    }

    public void setCodice_spedizione(int codice_spedizione) {
        this.codice_spedizione = codice_spedizione;
    }

    public void setData_ora_spedizione(Timestamp data_ora_partenza) {
        this.data_ora_spedizione = data_ora_partenza;
    }

    public void setData_ora_consegna(Timestamp data_ora_consegna) {
        this.data_ora_consegna = data_ora_consegna;
    }

    public void setPeso(double peso) {
        this.peso = peso;
    }

    public void setCosto(double costo) {
        this.costo = costo;
    }

    public void setMittente(Cliente mittente) {
        this.mittente = mittente;
    }

    public void setDestinatario(Cliente destinatario) {
        this.destinatario = destinatario;
    }

    public void setSede_partenza(Sede sede_partenza) {
        this.sede_partenza = sede_partenza;
    }

    public void setSede_arrivo(Sede sede_arrivo) {
        this.sede_arrivo = sede_arrivo;
    }

    public String toString() {
        return "{" + codice_spedizione + ", " + data_ora_spedizione + ", " + data_ora_consegna + ", " + peso + "Kg, " + costo + "€, " + mittente + ", " + destinatario + ", " + sede_partenza + ", " + sede_arrivo + "}";
    }
    
    
}
