CREATE DATABASE Spedizioni;

USE Spedizioni;

CREATE TABLE Clienti (
codice_cliente CHAR(5) NOT NULL,
ragione_sociale VARCHAR(25) NOT NULL,
indirizzo VARCHAR(50) NOT NULL,
CAP CHAR(5) NOT NULL,
citta VARCHAR(20) NOT NULL,
telefono VARCHAR(15),
email VARCHAR(25),
CONSTRAINT chiave_primaria PRIMARY KEY (codice_cliente)
);

INSERT INTO Clienti (codice_cliente, ragione_sociale, indirizzo, CAP, citta, telefono, email) VALUES
('00001', 'Rossi s.p.a', 'Via del mare, 1', '57100', 'Livorno', '0586-54321', 'info@rossi.it'),
('00002', 'Bianchi s.r.l.', 'Via della torre, 99', '56100', 'Pisa', '050-12345', 'bianchi.mario@bianchi.it'),
('00003', 'Neri & C.', 'Piazza della stazione, 12', '50100', 'Firenze', '055-98765', 'maria.neri@neri.it');

CREATE TABLE Sedi (
codice_sede CHAR(5) NOT NULL,
indirizzo VARCHAR(50) NOT NULL,
CAP CHAR(5) NOT NULL,
citta VARCHAR(20) NOT NULL,
telefono VARCHAR(15),
email VARCHAR(25),
CONSTRAINT chiave_primaria PRIMARY KEY (codice_sede)
);

INSERT INTO Sedi (codice_sede, indirizzo, CAP, citta, telefono, email) VALUES
('00001', 'Via della stazione, 1', '57100', 'Livorno', '0586-56789', 'livorno@agenzia_espressi.it'),
('00002', 'Via del parco, 99', '56100', 'Pisa', '050-98765', 'pisa@agenzia_espressi.it'),
('00003', 'Piazza del mercato, 12', '50100', 'Firenze', '055-67890', 'firenze@agenzia_espressi.it');


CREATE TABLE Spedizioni (
codice_spedizione INTEGER NOT NULL,
data_ora_spedizione TIMESTAMP NOT NULL,
data_ora_consegna TIMESTAMP,
peso REAL,
costo REAL,
mittente CHAR(5) NOT NULL,
destinatario CHAR(5) NOT NULL,
sede_partenza CHAR(5) NOT NULL,
sede_arrivo CHAR(5) NOT NULL,
CONSTRAINT chiave_primaria PRIMARY KEY (codice_spedizione),
CONSTRAINT spezioni_clienti_1 FOREIGN KEY (mittente) REFERENCES Clienti(codice_cliente),
CONSTRAINT spezioni_clienti_2 FOREIGN KEY (destinatario) REFERENCES Clienti(codice_cliente),
CONSTRAINT spezioni_sede_1 FOREIGN KEY (sede_partenza) REFERENCES Sedi(codice_sede),
CONSTRAINT spezioni_sede_2 FOREIGN KEY (sede_arrivo) REFERENCES Sedi(codice_sede)
);

INSERT INTO Spedizioni (codice_spedizione, data_ora_spedizione, data_ora_consegna, peso, costo, mittente, destinatario, sede_partenza, sede_arrivo) VALUES
(123, '2014-07-4 10:12:30', '2014-07-05 09:05:00', 0.100, 5.50, '00001', '00002', '00001', '00002'),
(999, '2014-07-6 18:15:50', '2000-01-01 00:00:00', 0.550, 15.00, '00003', '00002', '00003', '00002');
